﻿using System.ComponentModel;
using DevExpress.ExpressApp.DC;
using Xafari.Base;
using Xafari.DC;

namespace NonPersistentCollections.Module
{
	public interface IOwnerSupport
	{
		object Owner { get; } 
	}

	[DomainComponent]
	[NonPersistentDc]
	public interface OwnerSupport : IOwnerSupport
	{
		[Browsable(false)]
		new object Owner { get; }
	}

	[DomainLogic(typeof(OwnerSupport))]
	public class OwnerSupportLogic : DomainLogicBase<OwnerSupport>
	{
		public OwnerSupportLogic(OwnerSupport instance) : base(instance)
		{
		}

		public object Owner
		{
		    get
		    {
		        return this.Instance.GetValueByTerm<object>("Owner");
		    }
		}
	}
}