using System;
using System.Text;
using System.Linq;
using DevExpress.ExpressApp;
using System.ComponentModel;
using DevExpress.ExpressApp.DC;
using System.Collections.Generic;
using DevExpress.Persistent.Base;
using DevExpress.ExpressApp.Model;
using DevExpress.ExpressApp.Actions;
using DevExpress.ExpressApp.Editors;
using DevExpress.ExpressApp.Updating;
using DevExpress.ExpressApp.Model.Core;
using DevExpress.ExpressApp.Model.DomainLogics;
using DevExpress.ExpressApp.Model.NodeGenerators;
using NonPersistentCollections.Module.BusinessObjects;

namespace NonPersistentCollections.Module
{
	// For more typical usage scenarios, be sure to check out http://documentation.devexpress.com/#Xaf/clsDevExpressExpressAppModuleBasetopic.
	public sealed partial class NonPersistentCollectionsModule : ModuleBase
	{
		public NonPersistentCollectionsModule()
		{
			InitializeComponent();
		}
		public override IEnumerable<ModuleUpdater> GetModuleUpdaters(IObjectSpace objectSpace, Version versionFromDB)
		{
			ModuleUpdater updater = new DatabaseUpdate.Updater(objectSpace, versionFromDB);
			return new ModuleUpdater[] { updater };
		}
		public override void Setup(XafApplication application)
		{
			base.Setup(application);
			// Manage various aspects of the application UI and behavior at the module level.

			XafTypesInfo.Instance.RegisterEntity("DerivedMaster1", typeof(DerivedMaster1));
			XafTypesInfo.Instance.RegisterEntity("OneMoreDerivedMaster1", typeof(OneMoreDerivedMaster1));
			XafTypesInfo.Instance.RegisterEntity("Details1", typeof(Details1));
			XafTypesInfo.Instance.RegisterEntity("Details2", typeof(Details2));
			XafTypesInfo.Instance.RegisterEntity("Details3", typeof(Details3));

			XafTypesInfo.Instance.RegisterEntity("DerivedMaster2", typeof(DerivedMaster2));
			XafTypesInfo.Instance.RegisterEntity("DerivedMaster2Details1", typeof(DerivedMaster2Details1));
			XafTypesInfo.Instance.RegisterEntity("OneMoreDerivedMaster2", typeof(OneMoreDerivedMaster2));
			XafTypesInfo.Instance.RegisterEntity("OneMoreDerivedMaster2Details1", typeof(OneMoreDerivedMaster2Details1));
			XafTypesInfo.Instance.RegisterEntity("_Master2Details2", typeof(_Master2Details2));
		}
	}
}
